%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Fibonacci: klasyczna rekurencja

fibrec(0,0).
fibrec(1,1).

fibrec(N,M):- 
  N1 is N-1, N1>=0,
  N2 is N-2, N2>=0,
  fibrec(N1,M1),    % write(M1),nl,
  fibrec(N2,M2),!,  % write(M2),nl,nl,
  M is M1+M2.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Fibonacci - wersja iteracyjna (R. Bartak; ALi)

fibiter(N,F):-fibi(0,0,1,N,F).
   
fibi(N1,F1,F2,N,F):-
  N1<N,!,		  % test braku końca obliczeń
  N2 is N1+1,   	  % inkrementacja licznika
  F3 is F1+F2,		  % kolejny wyraz ciagu
  fibi(N2,F2,F3,N,F).     % "koniec-woła-początek" dla nowych parametrów

fibi(N,F,_,N,F).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Fibonacci - wersja loop-assert-fail. Wykorzystanie nawrotów.
:- dynamic(fiba/2). 
:- dynamic(licz/1).

fibstart(N) :-			% inicjalizacja obliczeń
   retractall(fiba(_,_)),
   retractall(licz(_)),
   assert(fiba(0,0)),
   assert(fiba(1,1)),
   assert(licz(0)),
   fibloop(N).

fibloop(N):-
   repeat,
   licz(I), I1 is I+1, I2 is I+2,
   fiba(I,F1), fiba(I1,F2),
   F3 is F1+F2,   % od 3 wyrazu
   assert(fiba(I2,F3)),
   retract(licz(I)), assert(licz(I1)),
   test(I1,N).


test(I1,N):- I1<N,!,fail.
test(N,N):- fiba(N,F), write(F),nl,!.
   
   
   
   












