:- dynamic(num/1).

%%% liczby.pl

%%% Prosty program ilustrujący ideę generacji/wyszukiwania rozwiazań w Prologu

% Fakty: definicja dostępnych cyfr. 
   cyfra(0).
   cyfra(1).
   cyfra(2).
   cyfra(3).
   cyfra(4).
   cyfra(5).   
   cyfra(6).
   cyfra(7).
   cyfra(8).
   cyfra(9).


% Przykładowa definicja liczby trzycyfrowej
   liczba(X):-
      cyfra(S),
      cyfra(D),
      cyfra(J),!,
      X is 100*S+10*D+J.

%%% Loop: end-calls-beginning

liczby_iter(A,Z) :-
   liaz(A,1,Z).

liaz(Z,I,Z):- write(Z),write('   '),write(I),nl,write('done'),!.
liaz(A,I,Z):- write(A), write('   '),write(I),nl,
   A1 is A+1, I1 is I+1,
   liaz(A1,I1,Z).

%%% Loop: find-fail
   liczba999 :-
      cyfra(S),
      cyfra(D),
      cyfra(J),
      X is 100*S+10*D+J,
      write(X),nl,
      fail.
liczba999:-
    write(koniec).

%%% Loop: iter_down

liczby_iter_down(A,Z) :- 
   lraz(A,1,Z).

lraz(1,I,Z) :- write(Z),write('   '),write(I),nl,write('done'),!.
lraz(A,I,Z) :- A1 is A-1, I1 is I+1, write(A1), write('   '), write(I1),nl,
   lraz(A1,I1,Z).

%%% Liczby: suma rec

sum_rec(A,A,A) :- !.
sum_rec(A,Z,S):-
  Z1 is Z-1,
  sum_rec(A,Z1,S1),
  S is S1+Z.
      
%%% Liczby: suma iter

sum_iter(A,Z,S) :-
  suit(A,0,Z,S).

suit(Z,W,Z,S):- S is !.
suit(A,W,Z,S):-
   W1 is W+A,
   A1 is A+1,
   suit(A1,W1,Z,S).


% Generacja i zapamiętanie liczb z zadanego zakresu

generate_and_assert(A,Z):-
   liczba(X),
   X >= A,
   X =< Z,
   assert(num(X)),
   fail.

generate_and_assert(_,_):-
   num(X),
   write(X),nl,
   fail.

generate_and_assert(_,_):-
   write('Done').

clear_numbers :-
   retract(num(_)),
   fail.

clear_numbers :-
   write('Done: empty').


% Modyfikacje:
% 1. Zmiana zakresu.
% 2. Zmiana kolejności.
% 3. Zmiana sposobu wypisywania.

% eof
